/* Prototypes for GNU compiler,
   for Freescale (Motorola) M68HC05 microcontrollers
   Copyright (C) 2005 Free Software Foundation, Inc.
   Copyright (C) 2005 Martin Kgler
   Contributed by Martin Kgler (mkoegler@auto.tuwien.ac.at)

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GCC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301, USA.
*/

extern void m68hc05_override_options PARAMS ((void));
extern void m68hc05_optimization_options PARAMS ((int, int));

extern int initial_elimination_offset PARAMS ((int from, int to));
extern int can_eliminate PARAMS ((int from, int to));
extern int function_arg_regno_p PARAMS ((int r));

extern enum reg_class m68hc05_regno_reg_class PARAMS ((int r));
extern enum reg_class m68hc05_reg_class_from_letter PARAMS ((int c));
extern int m68hc05_regno_valid_for_base PARAMS ((int r));

extern void expand_prolog PARAMS ((void));
extern void expand_epilog PARAMS ((void));

#ifdef HAVE_MACHINE_MODES
extern int class_max_nregs
PARAMS ((enum reg_class class, enum machine_mode mode));
extern int m68hc05_hard_regno_mode_ok
PARAMS ((int regno, enum machine_mode mode));
extern int hard_regno_regs PARAMS ((int regno, enum machine_mode mode));

extern int register_move_cost
PARAMS ((enum machine_mode mode, enum reg_class from, enum reg_class to));
extern int memory_move_cost
PARAMS ((enum machine_mode mode, enum reg_class regclass, int in));
#endif

extern int extra_memory_constraint PARAMS ((char m));
extern int m68hc05_no_epilog_needed PARAMS ((void));

#ifdef RTX_CODE

extern int extra_constraint PARAMS ((rtx x, int c));

extern void print_operand PARAMS ((FILE * file, rtx x, int code));
extern void print_operand_address PARAMS ((FILE * file, rtx addr));

extern void m68hc05_initialize_trampoline
PARAMS ((rtx tramp, rtx fnaddr, rtx ctx));
extern void notice_update_cc PARAMS ((rtx body, rtx insn));

extern int is_rega_rtx PARAMS ((rtx x));
extern int is_regx_rtx PARAMS ((rtx x));

#ifdef HAVE_MACHINE_MODES
extern rtx m68hc05_libcall_value PARAMS ((enum machine_mode mode));

extern int legitimate_address_p
PARAMS ((enum machine_mode mode, rtx x, int strict));
extern rtx legitimize_address
PARAMS ((rtx x, rtx oldx, enum machine_mode mode));
extern int legitimize_reload_address
PARAMS ((rtx * x, enum machine_mode mode, int opnum, int type,
	 int ind));


extern rtx genSUBREG
PARAMS ((rtx op, enum machine_mode mode, int byte,
	 enum machine_mode outer_mode));
extern rtx genXLoad PARAMS ((rtx op, enum machine_mode mode, int byte));
extern rtx genXClobber PARAMS ((rtx op, enum machine_mode mode, int byte));

extern int spaddr_operand PARAMS ((rtx op, enum machine_mode mode));
extern int constant_addr PARAMS ((rtx op));

#endif

#ifdef TREE_CODE

extern void init_cumulative_args
PARAMS ((CUMULATIVE_ARGS * cum, tree fntype, rtx libname, tree fndecl));
extern rtx m68hc05_function_value PARAMS ((tree type, tree func));

#ifdef HAVE_MACHINE_MODES
extern rtx function_arg
PARAMS ((CUMULATIVE_ARGS * cum, enum machine_mode mode, tree type,
	 int named));
#endif

#endif

#endif

#ifdef TREE_CODE

#ifdef HAVE_MACHINE_MODES
extern void function_arg_advance
PARAMS ((CUMULATIVE_ARGS * cum, enum machine_mode mode, tree type,
	 int named));
#endif

extern int first_parm_offset PARAMS ((tree fndcl));
#endif


