/* GCC M68HC05 hooks and functions
   for Freescale (Motorola) M68HC05 microcontrollers
   Copyright (C) 2005 Free Software Foundation, Inc.
   Copyright (C) 2005 Martin Kgler
   Contributed by Martin Kgler (mkoegler@auto.tuwien.ac.at)

This file is part of GCC.

GCC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

GCC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GCC; see the file COPYING.  If not, write to the Free
Software Foundation, 51 Franklin Street, Fifth Floor, Boston, MA
02110-1301, USA.
*/

/* warning - not cleaned up */

#include <stdio.h>
#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "regs.h"
#include "hard-reg-set.h"
#include "real.h"
#include "insn-config.h"
#include "conditions.h"
#include "insn-attr.h"
#include "flags.h"
#include "reload.h"
#include "tree.h"
#include "output.h"
#include "expr.h"
#include "toplev.h"
#include "obstack.h"
#include "function.h"
#include "recog.h"
#include "ggc.h"
#include "tm_p.h"
#include "target.h"
#include "target-def.h"
#include "params.h"

#include "basic-block.h"
#include "optabs.h"
#include "gstab.h"
#include "langhooks.h"

/* register range for argument passing */
#define FIRST_CUM_REG REG_B
#define LAST_CUM_REG REG_K


static void m68hc05_select_section
PARAMS ((tree decl, int reloc, unsigned HOST_WIDE_INT align));
static void m68hc05_output_internal_label
PARAMS ((FILE * stream, const char *prefix, unsigned long num));
static bool m68hc05_rtx_costs
PARAMS ((rtx x, int code, int outer_code, int *total));
static void m68hc05_init_libfuncs PARAMS ((void));
static void m68hc05_reorg PARAMS ((void));
static bool m68hc05_assemble_integer PARAMS ((rtx, unsigned int, int));
static int save_frame_size PARAMS ((void));
static const char *ptrreg_to_str PARAMS ((int));
static int m68hc05_num_arg_regs PARAMS ((enum machine_mode, tree));
extern int constant_addr PARAMS ((rtx op));
extern int spaddr_operand PARAMS ((rtx op, enum machine_mode mode));
const struct attribute_spec m68hc05_attribute_table[];
static int m68hc05_address_cost PARAMS ((rtx));
static void m68hc05_init_builtins PARAMS ((void));
static bool m68hc05_scalar_mode_supported_p PARAMS ((enum machine_mode mode));
static int m68hc05_nosave_function_p (tree func);
static int m68hc05_extract_mem_ref_flags (tree expr);
static int m68hc05_compare_addrspace (enum addrspace_type,
				      enum addrspace_type);
static enum addrspace_type m68hc05_merge_addrspace (enum addrspace_type,
						    enum addrspace_type);
static int stack_register (rtx op);
int
default_rtx_costs (rtx x,
		   enum rtx_code code, enum rtx_code outer_code, int *total);
int in_optimizing (void);

/* GCC target structure */

#undef TARGET_ASM_NAMED_SECTION
#define TARGET_ASM_NAMED_SECTION  default_elf_asm_named_section
#undef TARGET_ASM_SELECT_SECTION
#define TARGET_ASM_SELECT_SECTION  m68hc05_select_section
#undef TARGET_ASM_INTERNAL_LABEL
#define TARGET_ASM_INTERNAL_LABEL m68hc05_output_internal_label
#undef TARGET_RTX_COSTS
#define TARGET_RTX_COSTS m68hc05_rtx_costs
#undef TARGET_ADDRESS_COST
#define TARGET_ADDRESS_COST m68hc05_address_cost
#undef TARGET_MACHINE_DEPENDENT_REORG
#define TARGET_MACHINE_DEPENDENT_REORG m68hc05_reorg
#undef TARGET_INIT_LIBFUNCS
#define TARGET_INIT_LIBFUNCS m68hc05_init_libfuncs
#undef TARGET_ASM_INTEGER
#define TARGET_ASM_INTEGER m68hc05_assemble_integer
#undef TARGET_HAVE_NAMED_SECTIONS
#define TARGET_HAVE_NAMED_SECTIONS true
#undef  TARGET_ATTRIBUTE_TABLE
#define TARGET_ATTRIBUTE_TABLE m68hc05_attribute_table
#undef TARGET_INIT_BUILTINS
#define TARGET_INIT_BUILTINS m68hc05_init_builtins
#undef TARGET_SCALAR_MODE_SUPPORTED_P
#define TARGET_SCALAR_MODE_SUPPORTED_P m68hc05_scalar_mode_supported_p
#undef TARGET_EXTRACT_MEM_REF_FLAGS
#define TARGET_EXTRACT_MEM_REF_FLAGS m68hc05_extract_mem_ref_flags
#undef TARGET_COMPARE_ADDRSPACE
#define TARGET_COMPARE_ADDRSPACE m68hc05_compare_addrspace
#undef TARGET_MERGE_ADDRSPACE
#define TARGET_MERGE_ADDRSPACE m68hc05_merge_addrspace

struct gcc_target targetm = TARGET_INITIALIZER;

/* reg class functions */

enum reg_class
m68hc05_regno_reg_class (int r)
{
  if (r == REG_A)
    return A_REG;
  if (r == REG_X)
    return X_REG;
  if (r == REG_SP)
    return STACK_REG;
  if (r == REG_FP)
    return STACK_REG;
  if (r == REG_B)
    return REGS_B;
  if (r == REG_C)
    return REGS_C;
  if (r == REG_D)
    return REGS_D;
  if (r == REG_E)
    return REGS_E;
  if (r == REG_F)
    return REGS_F;
  if (r == REG_G)
    return REGS_FG;
  if (r == REG_H)
    return REGS_H;
  if (r == REG_I)
    return REGS_HI;
  if (r == REG_J)
    return GENERAL_REGS;
  if (r == REG_K)
    return REGS_KLMN;
  if (r == REG_L)
    return REGS_KLMN;
  if (r == REG_M)
    return REGS_KLMN;
  if (r == REG_N)
    return REGS_KLMN;
  return ALL_REGS;
}


/* A C expression which defines the machine-dependent operand
   constraint letters for register classes.  If C is such a
   letter, the value should be the register class corresponding to
   it.  Otherwise, the value should be `NO_REGS'.  The register
   letter `r', corresponding to class `GENERAL_REGS', will not be
   passed to this macro; you do not need to handle it.  */

enum reg_class
m68hc05_reg_class_from_letter (int c)
{
  switch (c)
    {
    case 'a':
      return A_REG;
    case 'x':
      return X_REG;
    case 'w':
      return STACK_REG;
    case 'b':
      return POINTER_REGS;
    case 'z':
      return REGS_B;
    case 'c':
      return REGS_C;
    case 'd':
      return REGS_D;
    case 'e':
      return REGS_E;
    case 'f':
      return REGS_F;
    case 'h':
      return REGS_H;
    case 'q':
      return REGS_BC;
    case 't':
      return REGS_DE;
    case 'u':
      return REGS_FG;
    case 'v':
      return REGS_HI;
    case 'y':
      return REGS_KLMN;

    default:
      break;
    }
  return NO_REGS;
}


/* Return maximum number of consecutive registers of
   class CLASS needed to hold a value of mode MODE.  */

int
class_max_nregs (enum reg_class class ATTRIBUTE_UNUSED,
		 enum machine_mode mode)
{
  return ((GET_MODE_SIZE (mode) + UNITS_PER_WORD - 1) / UNITS_PER_WORD);
}

int
m68hc05_hard_regno_mode_ok (int regno, enum machine_mode mode)
{
  if (GET_MODE_SIZE (mode) == 1)
    return 1;
  return (regno >= REG_B && regno + GET_MODE_SIZE (mode) - 1 <= REG_N);
}

/* stack and frame pointer (and the other related registers) are stored as
   QI value, but the Pmode is HI. Tell gcc to accept HI access on these */

int
hard_regno_regs (int regno, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  if (regno == REG_SP && mode == HImode)
    return 1;
  if (regno == REG_AG && mode == HImode)
    return 1;
  if (regno == REG_VFP && mode == HImode)
    return 1;
  if (regno == REG_FP && mode == HImode)
    return 1;
  return ((GET_MODE_SIZE (mode) + UNITS_PER_WORD - 1) / UNITS_PER_WORD);
}

int
m68hc05_regno_valid_for_base (int r)
{
  return (REG_B <= r && r <= REG_M) || r == REG_SP || r == REG_AG
    || r == REG_VFP || r == REG_FP;
}

/* code expansion */

void
m68hc05_initialize_trampoline (rtx tramp, rtx fnaddr, rtx ctx)
{
  rtx reg = gen_reg_rtx (Pmode);
  emit_move_insn (reg, ctx);
  emit_move_insn (gen_rtx_MEM (QImode, plus_constant (tramp, 0)),
		  GEN_INT (0xa6 | (-1 & ~0xff)));
  emit_move_insn (gen_rtx_MEM (QImode, plus_constant (tramp, 1)),
		  simplify_gen_subreg (QImode, reg, GET_MODE (reg), 0));
  emit_move_insn (gen_rtx_MEM (QImode, plus_constant (tramp, 2)),
		  GEN_INT (0xb7 | (-1 & ~0xff)));
  emit_move_insn (gen_rtx_MEM (QImode, plus_constant (tramp, 3)),
		  gen_rtx_CONST (QImode,
				 gen_rtx_SYMBOL_REF (Pmode,
						     reg_names
						     [STATIC_CHAIN_REGNUM])));
  emit_move_insn (gen_rtx_MEM (QImode, plus_constant (tramp, 4)),
		  GEN_INT (0xa6 | (-1 & ~0xff)));
  emit_move_insn (gen_rtx_MEM (QImode, plus_constant (tramp, 5)),
		  simplify_gen_subreg (QImode, reg, GET_MODE (reg), 1));
  emit_move_insn (gen_rtx_MEM (QImode, plus_constant (tramp, 6)),
		  GEN_INT (0xb7 | (-1 & ~0xff)));
  emit_move_insn (gen_rtx_MEM (QImode, plus_constant (tramp, 7)),
		  gen_rtx_CONST (QImode,
				 gen_rtx_SYMBOL_REF (Pmode,
						     reg_names
						     [STATIC_CHAIN_REGNUM +
						      1])));
  emit_move_insn (gen_rtx_MEM (QImode, plus_constant (tramp, 8)),
		  GEN_INT (0xcc | (-1 & ~0xff)));
  emit_move_insn (gen_rtx_MEM (HImode, plus_constant (tramp, 9)), fnaddr);

}

/* output helper functions */

static bool
m68hc05_assemble_integer (rtx x ATTRIBUTE_UNUSED,
			  unsigned int size ATTRIBUTE_UNUSED,
			  int aligned_p ATTRIBUTE_UNUSED)
{
  const char *op = integer_asm_op (size, aligned_p);
  return op && (assemble_integer_with_op (op, x), true);
}

static void
m68hc05_output_internal_label (FILE * stream, const char *prefix,
			       unsigned long num)
{
  fprintf (stream, ".%s%ld:\n", prefix, num);
}

/* Return a pointer register name as a string */

static const char *
ptrreg_to_str (int regno)
{
  return reg_names[regno];
}

/* Output ADDR to FILE as address */

const char *subregfuncs[] = { "lo8", "hi8", "hlo8", "hhi8" };

void
print_operand_address (FILE * file, rtx addr)
{
  switch (GET_CODE (addr))
    {
    case REG:
      fprintf (file, ptrreg_to_str (REGNO (addr)));
      break;
    case PLUS:
      if (REG_P (XEXP (addr, 0)))
	{
	  fprintf (file, "%ld_", INTVAL (XEXP (addr, 1)));
	  fprintf (file, ptrreg_to_str (REGNO (XEXP (addr, 0))));
	  break;
	}
      goto def;
    case SUBREG:
      fprintf (file, "%s(",
	       subregfuncs[GET_MODE_SIZE (GET_MODE (XEXP (addr, 0))) -
			   XINT (addr, 1) - 1]);
      output_addr_const (file, XEXP (addr, 0));
      fprintf (file, ")");
      break;
    def:
    default:
      output_addr_const (file, addr);
    }
}


/* Output X as assembler operand to file FILE */

void
print_operand (FILE * file, rtx x, int code)
{
  if (GET_CODE (x) == CONST)
    x = XEXP (x, 0);
  if (code == 'o' && GET_CODE (x) == MEM)
    {
      rtx op = XEXP (x, 0);
      if (REG_P (op)
	  && (REGNO (op) == REG_SP || REGNO (op) == REG_FP
	      || REGNO (op) == REG_X))
	{
	  fprintf (file, "%d", 0);
	  return;
	}
      else
	if (GET_CODE (op) == PLUS &&
	    REG_P (XEXP (op, 0)) &&
	    (REGNO (XEXP (op, 0)) == REG_SP || REGNO (XEXP (op, 0)) == REG_FP
	     || REGNO (XEXP (op, 0)) == REG_X)
	    && GET_CODE (XEXP (op, 1)) == CONST_INT)
	{
	  fprintf (file, "%ld", INTVAL (XEXP (op, 1)));
	  return;
	}
      else
	abort ();

    }
  if (REG_P (x))
    {
      fprintf (file, reg_names[true_regnum (x)]);
    }
  else if (GET_CODE (x) == CONST_INT)
    fprintf (file, "%ld", INTVAL (x));
  else if (GET_CODE (x) == MEM)
    {
      rtx addr = XEXP (x, 0);
      print_operand_address (file, addr);
    }
  else if (GET_CODE (x) == CONST_DOUBLE && GET_MODE (x) == SFmode)
    {
      REAL_VALUE_TYPE r;
      long l;

      REAL_VALUE_FROM_CONST_DOUBLE (r, x);
      REAL_VALUE_TO_TARGET_SINGLE (r, l);
      fprintf (file, "0x%lx", l);
    }
  else if (GET_CODE (x) == CONST_DOUBLE && (GET_MODE (x) == DFmode))
    {
      REAL_VALUE_TYPE r;
      long l[2];

      REAL_VALUE_FROM_CONST_DOUBLE (r, x);
      REAL_VALUE_TO_TARGET_DOUBLE (r, l);
      fprintf (file, "0x%lx", (code == 'A' ? l[1] : l[0]));
    }
  else
    if (GET_CODE (x) == SUBREG && GET_CODE (XEXP (x, 0)) == CONST_DOUBLE
	&& GET_MODE (XEXP (x, 0)) == SFmode)
    {
      REAL_VALUE_TYPE r;
      long l;

      REAL_VALUE_FROM_CONST_DOUBLE (r, XEXP (x, 0));
      REAL_VALUE_TO_TARGET_SINGLE (r, l);
      l = 0xff & (l >> (24 - (XINT (x, 1)) * 8));
      fprintf (file, "0x%lx", l);
    }
  else if (GET_CODE (x) == SUBREG && GET_CODE (XEXP (x, 0)) == CONST_DOUBLE
	   && (GET_MODE (XEXP (x, 0)) == DFmode))
    {
      REAL_VALUE_TYPE r;
      long l[2];

      REAL_VALUE_FROM_CONST_DOUBLE (r, XEXP (x, 0));
      REAL_VALUE_TO_TARGET_DOUBLE (r, l);
      l[0] =
	0xff & (l[((XINT (x, 1)) / 4)] >> (24 - ((XINT (x, 1)) % 4) * 8));
      fprintf (file, "0x%lx", l[0]);
    }
  else if (GET_CODE (x) == SUBREG && GET_CODE (XEXP (x, 0)) == CONST_DOUBLE
	   && (GET_MODE (XEXP (x, 0)) == DImode))
    {
      int pos = XINT (x, 1);
      long l;
      if (pos < 4)
	l = CONST_DOUBLE_HIGH (XEXP (x, 0));
      else
	l = CONST_DOUBLE_LOW (XEXP (x, 0));
      l = 0xff & (l >> (24 - (pos % 4) * 8));
      fprintf (file, "0x%lx", l);
    }
  else
    print_operand_address (file, x);
}

/* Like default implementation, only force switch to data section
   So every variable is put into its own .data subsection
*/
static void
m68hc05_select_section (tree decl, int reloc,
			unsigned HOST_WIDE_INT align ATTRIBUTE_UNUSED)
{
  bool readonly = false;

  if (DECL_P (decl))
    {
      if (decl_readonly_section (decl, reloc))
	readonly = true;
    }
  else if (TREE_CODE (decl) == CONSTRUCTOR)
    {
      if (!((flag_pic && reloc)
	    || !TREE_READONLY (decl)
	    || TREE_SIDE_EFFECTS (decl) || !TREE_CONSTANT (decl)))
	readonly = true;
    }
  else if (TREE_CODE (decl) == STRING_CST)
    readonly = true;
  else if (!(flag_pic && reloc))
    readonly = true;

  if (readonly)
    readonly_data_section ();
  else
    {
      text_section ();
      data_section ();
    }
}

/* argument / frame handling */

/* Ceate an RTX representing the place where a
   library function returns a value of mode MODE.  */

rtx
m68hc05_libcall_value (enum machine_mode mode)
{
  /* use RegC for return of QI values so that library functions written in C also work */
  if (mode == QImode)
    return gen_rtx_REG (mode, RET_REGISTER + 1);

  return gen_rtx_REG (mode, RET_REGISTER);
}

/* Create an RTX representing the place where a
   function returns a value of data type VALTYPE.  */

rtx
m68hc05_function_value (tree type, tree func ATTRIBUTE_UNUSED)
{
  unsigned int offs;

  if (TYPE_MODE (type) != BLKmode)
    return m68hc05_libcall_value (TYPE_MODE (type));

  offs = int_size_in_bytes (type);

  return gen_rtx_REG (BLKmode, RET_REGISTER);
}

int
function_arg_regno_p (int r)
{
  return (r >= FIRST_CUM_REG && r <= LAST_CUM_REG);
}

/* Returns the number of registers to allocate for a function argument.  */

static int
m68hc05_num_arg_regs (enum machine_mode mode, tree type)
{
  int size;

  if (mode == BLKmode)
    size = int_size_in_bytes (type);
  else
    size = GET_MODE_SIZE (mode);

  return size;
}

/* Initializing the variable cum for the state at the beginning
   of the argument list.  */

void
init_cumulative_args (CUMULATIVE_ARGS * cum, tree fntype, rtx libname,
		      tree fndecl ATTRIBUTE_UNUSED)
{
  cum->nregs = LAST_CUM_REG - FIRST_CUM_REG;
  cum->regno = FIRST_CUM_REG;
  if (!libname && fntype)
    {
      int stdarg = (TYPE_ARG_TYPES (fntype) != 0
		    && (TREE_VALUE (tree_last (TYPE_ARG_TYPES (fntype)))
			!= void_type_node));
      if (stdarg)
	cum->nregs = 0;
    }
}


/* Controls whether a function argument is passed
   in a register, and which register. */

rtx
function_arg (CUMULATIVE_ARGS * cum, enum machine_mode mode, tree type,
	      int named ATTRIBUTE_UNUSED)
{
  int bytes = m68hc05_num_arg_regs (mode, type);

  if (mode == BLKmode)
    return NULL_RTX;

  if (cum->nregs && bytes <= cum->nregs)
    return gen_rtx_REG (mode, cum->regno);

  return NULL_RTX;
}

/* Update the summarizer variable CUM to advance past an argument
   in the argument list.  */

void
function_arg_advance (CUMULATIVE_ARGS * cum, enum machine_mode mode,
		      tree type, int named ATTRIBUTE_UNUSED)
{
  int bytes = m68hc05_num_arg_regs (mode, type);

  if (mode == BLKmode)
    return;

  cum->nregs -= bytes;
  cum->regno += bytes;

  if (cum->nregs <= 0)
    {
      cum->nregs = 0;
      cum->regno = FIRST_CUM_REG;
    }
}

int
first_parm_offset (tree fndcl ATTRIBUTE_UNUSED)
{
  return 0;
}

static int
save_reg (int regno)
{
  if (m68hc05_nosave_function_p (current_function_decl))
    return 0;
  return (regs_ever_live[regno]
	  && !call_used_regs[regno] && !fixed_regs[regno]);
}

static int
save_frame_size (void)
{
  int i;
  int size = 0;
  if (frame_pointer_needed)
    size++;
  for (i = REG_B; i <= REG_N; i++)
    if (save_reg (i))
      size++;
  return size;
}

int
initial_elimination_offset (int from, int to)
{
  if (from == to)
    return 0;

  if (from == FRAME_POINTER_REGNUM && to == HARD_FRAME_POINTER_REGNUM)
    return -save_frame_size ();
  else if (from == FRAME_POINTER_REGNUM && to == STACK_POINTER_REGNUM)
    return get_frame_size () + current_function_outgoing_args_size;
  else if (from == ARG_POINTER_REGNUM && to == HARD_FRAME_POINTER_REGNUM)
    return 0;
  else if (from == ARG_POINTER_REGNUM && to == STACK_POINTER_REGNUM)
    return save_frame_size () + get_frame_size () +
      current_function_outgoing_args_size;
  else
    abort ();
}

int
can_eliminate (int from ATTRIBUTE_UNUSED, int to)
{
  if (to == HARD_FRAME_POINTER_REGNUM)
    return 1;
  if (to == STACK_POINTER_REGNUM)
    return 1;
  abort ();
}


static rtx
save_stack_location (int offset)
{
  return gen_rtx_MEM (QImode,
		      gen_rtx_PLUS (Pmode, stack_pointer_rtx,
				    GEN_INT (-offset - 1)));
}

void
expand_prolog (void)
{
  int size =
    get_frame_size () + save_frame_size () +
    current_function_outgoing_args_size;
  int offset = 0;
  int i;

  if (frame_pointer_needed)
    {
      emit_insn (gen_movqi
		 (save_stack_location (offset++),
		  gen_rtx_REG (QImode, HARD_FRAME_POINTER_REGNUM)));
    }
  for (i = REG_B; i <= REG_N; i++)
    if (save_reg (i))
      emit_insn (gen_movqi
		 (save_stack_location (offset++), gen_rtx_REG (QImode, i)));

  if (frame_pointer_needed)
    emit_move_insn (hard_frame_pointer_rtx, stack_pointer_rtx);

  if (size > 0)
    emit_insn (gen_addhi3 (stack_pointer_rtx,
			   stack_pointer_rtx, GEN_INT (-size)));

}

int
m68hc05_no_epilog_needed (void)
{
  if (frame_pointer_needed)
    return 0;
  if (get_frame_size () + save_frame_size () +
      current_function_outgoing_args_size > 0)
    return 0;
  return 1;
}

void
expand_epilog (void)
{
  int offset = 0;
  int size =
    get_frame_size () + save_frame_size () +
    current_function_outgoing_args_size;
  int i;

  /* Cut off any dynamic stack created.  */
  if (frame_pointer_needed)
    emit_move_insn (stack_pointer_rtx, hard_frame_pointer_rtx);
  else
    {
      if (size > 0)
	emit_insn (gen_addhi3 (stack_pointer_rtx,
			       stack_pointer_rtx, GEN_INT (size)));
    }

  if (frame_pointer_needed)
    {
      emit_insn (gen_movqi
		 (gen_rtx_REG (QImode, HARD_FRAME_POINTER_REGNUM),
		  save_stack_location (offset++)));
      emit_insn (gen_rtx_USE (VOIDmode, hard_frame_pointer_rtx));
    }

  for (i = REG_B; i <= REG_N; i++)
    if (save_reg (i))
      {
	emit_insn (gen_movqi
		   (gen_rtx_REG (QImode, i), save_stack_location (offset++)));
	emit_insn (gen_rtx_USE (VOIDmode, gen_rtx_REG (QImode, i)));
      }

  emit_jump_insn (gen_return_internal ());
}

/* m68hc05 higlevel / lowlevel RTL helper code */

/* generate load instruction for X register, if needed */

rtx
genXLoad (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED,
	  int byte ATTRIBUTE_UNUSED)
{
  int reg = REG_X;

  if (extra_constraint (op, 'C'))
    return gen_rtx_SET (QImode, gen_rtx_REG (QImode, REG_X),
			simplify_gen_subreg (QImode, XEXP (op, 0), Pmode, 1));

  if (extra_constraint (op, 'W'))
    reg = REG_FP;
  else if (extra_constraint (op, 'U'))
    reg = REG_SP;

  if (reg != REG_X)
    return gen_rtx_SET (QImode, gen_rtx_REG (QImode, REG_X),
			gen_rtx_REG (QImode, reg));
  else
    return gen_nop ();
}

/* extract part of the operand and convert refereneces to the stack */
rtx
genSUBREG (rtx op, enum machine_mode mode, int byte,
	   enum machine_mode outer_mode)
{
  rtx old = op;
  if (GET_CODE (op) == SUBREG)
    {
      byte += XINT (op, 1);
      op = XEXP (op, 0);
    }
  if (GET_MODE (op) == VOIDmode && GET_CODE (op) != CONST_DOUBLE
      && GET_CODE (op) != CONST_INT)
    {
      op = shallow_copy_rtx (op);
      PUT_MODE (op, outer_mode);
    }
  if (extra_constraint (op, 'U'))
    {
      int offset = 0;
      if (GET_CODE (XEXP (op, 0)) == PLUS)
	offset = INTVAL (XEXP (XEXP (op, 0), 1));
      else
	offset = 0;
      op =
	gen_rtx_MEM (GET_MODE (op),
		     gen_rtx_PLUS (Pmode, gen_rtx_REG (Pmode, REG_X),
				   GEN_INT (offset)));
      MEM_COPY_ATTRIBUTES (op, old);
    }
  if (extra_constraint (op, 'C'))
    {
      op = gen_rtx_MEM (GET_MODE (op), gen_rtx_REG (Pmode, REG_X));
      MEM_COPY_ATTRIBUTES (op, old);
    }

  if (GET_CODE (op) == SYMBOL_REF || GET_CODE (op) == LABEL_REF
      || GET_CODE (op) == CONST)
    {
      return gen_rtx_CONST (mode, gen_rtx_SUBREG (mode, op, byte));
    }
  if (GET_CODE (op) == MEM)
    {
      return adjust_address_nv (op, mode, byte);
    }
  return simplify_gen_subreg (mode, op, outer_mode, byte);
}

/* indicate, that the X register was changed, if a base pointer was used */

rtx
genXClobber (rtx op, enum machine_mode mode ATTRIBUTE_UNUSED,
	     int byte ATTRIBUTE_UNUSED)
{
  if (extra_constraint (op, 'Q') && !extra_constraint (op, 'U'))
    return gen_rtx_CLOBBER (VOIDmode, gen_rtx_REG (QImode, REG_X));
  return gen_nop ();
}

/*  constrain helper */

#define IS_SP(x) (REG_P(x)&&(REGNO(x)==REG_SP||(REGNO(x)==REG_FP)))
#define IS_FP(x) (REG_P(x)&&((REGNO(x)==REG_FP)))
#define IS_X(x) (REG_P(x)&&((REGNO(x)==REG_X)))

int
extra_constraint (rtx x, int c)
{
  /* memory pointer to by base register */
  if (c == 'Q'
      && GET_CODE (x) == MEM
      && REG_P (XEXP (x, 0))
      && TEST_HARD_REG_CLASS (POINTER_REGS, REGNO (XEXP (x, 0))))
    return 1;
  if (c == 'Q'
      && GET_CODE (x) == MEM
      && GET_CODE (XEXP (x, 0)) == PLUS
      && REG_P (XEXP (XEXP (x, 0), 0))
      && GET_CODE (XEXP (XEXP (x, 0), 1)) == CONST_INT
      && 0 <= INTVAL (XEXP (XEXP (x, 0), 1))
      && 8 >= INTVAL (XEXP (XEXP (x, 0), 1)) + GET_MODE_SIZE (GET_MODE (x))
      && (TEST_HARD_REG_CLASS (POINTER_REGS, REGNO (XEXP (XEXP (x, 0), 0)))
	  || REGNO (XEXP (XEXP (x, 0), 0)) >= FIRST_PSEUDO_REGISTER))
    return 1;
  /* memory pointer to by a base register for lowlevel RTL (with offset 0-7) */
  if (c == 'Q' && is_lowlevel ()
      && GET_CODE (x) == MEM
      && GET_CODE (XEXP (x, 0)) == PLUS
      && REG_P (XEXP (XEXP (x, 0), 0))
      && GET_CODE (XEXP (XEXP (x, 0), 1)) == CONST_INT
      && 0 <= INTVAL (XEXP (XEXP (x, 0), 1))
      && 7 >= INTVAL (XEXP (XEXP (x, 0), 1))
      && (TEST_HARD_REG_CLASS (POINTER_REGS, REGNO (XEXP (XEXP (x, 0), 0)))
	  || REGNO (XEXP (XEXP (x, 0), 0)) >= FIRST_PSEUDO_REGISTER))
    return 1;
  /* memory at fixed location */
  if ((c == 'A' || c == 'B')
      && GET_CODE (x) == MEM && CONSTANT_P (XEXP (x, 0)))
    return 1;
  /* Stack pointer */
  if (c == 'S' && REG_P (x) && REGNO (x) == REG_SP)
    return 1;
  /* frame pointer */
  if (c == 'Z' && REG_P (x) && REGNO (x) == REG_FP)
    return 1;
  /* memory on stack relative to frame pointer */
  if ((c == 'W')
      && GET_CODE (x) == MEM
      &&
      ((GET_CODE (XEXP (x, 0)) == PLUS
	&& IS_FP (XEXP (XEXP (x, 0), 0))
	&& CONSTANT_P (XEXP (XEXP (x, 0), 1))) || (IS_FP (XEXP (x, 0)))))
    return 1;
  if ((c == 'D')
      && loram_operand (x, VOIDmode)
      && GET_CODE (x) == MEM
      &&
      ((GET_CODE (XEXP (x, 0)) == PLUS
	&& IS_X (XEXP (XEXP (x, 0), 0))
	&& CONSTANT_P (XEXP (XEXP (x, 0), 1))) || (IS_X (XEXP (x, 0)))))
    return 1;
  /* memory at X + constant address */
  if ((c == 'Y')
      && GET_CODE (x) == MEM
      &&
      ((GET_CODE (XEXP (x, 0)) == PLUS
	&& IS_X (XEXP (XEXP (x, 0), 0))
	&& CONSTANT_P (XEXP (XEXP (x, 0), 1))) || (IS_X (XEXP (x, 0)))))
    return 1;
  /* location on the stack */
  if ((c == 'T' || c == 'U')
      && GET_CODE (x) == MEM
      &&
      ((GET_CODE (XEXP (x, 0)) == PLUS
	&& IS_SP (XEXP (XEXP (x, 0), 0))
	&& CONSTANT_P (XEXP (XEXP (x, 0), 1))) || (IS_SP (XEXP (x, 0)))))
    return 1;
  /* accept not reloaded registers in reload process, which can be put
     on the stack */
  if (c == 'R' && reload_in_progress)
    {
      rtx y = x;
      if (GET_CODE (y) == SUBREG)
	y = XEXP (y, 0);
      if (GET_CODE (y) == REG
	  && REGNO (y) >= FIRST_PSEUDO_REGISTER
	  && reg_renumber[REGNO (y)] < 0
	  && ((reg_equiv_mem[REGNO (y)] != 0
	       && extra_constraint (reg_equiv_mem[REGNO (y)], 'T'))))
	return 1;
    }
  if (c == 'C' && loram_operand (x, VOIDmode)
      && GET_CODE (x) == MEM
      && REG_P (XEXP (x, 0))
      && TEST_HARD_REG_CLASS (POINTER_REGS, REGNO (XEXP (x, 0))))
    return 1;
  return 0;
}

/* constrains A, T are the same as B und U,
   but are used to indicate, that the general reload
   to memory is possible */

int
extra_memory_constraint (char m)
{
  if (m == 'A' || m == 'T' || m == 'Q')
    return 1;
  return 0;
}

/* constant */
int
constant_addr (rtx op)
{
  if (CONSTANT_P (op))
    return 1;
  return 0;
}

static int
stack_register (rtx op)
{
  if (REG_P (op) && REGNO (op) == REG_SP)
    return 1;
  if (REG_P (op) && REGNO (op) == REG_AG)
    return 1;
  if (REG_P (op) && REGNO (op) == REG_VFP)
    return 1;
  if (REG_P (op) && REGNO (op) == REG_FP)
    return 1;
  if (rtx_equal_p (op, virtual_stack_vars_rtx))
    return 1;
  if (rtx_equal_p (op, virtual_incoming_args_rtx))
    return 1;
  if (rtx_equal_p (op, virtual_outgoing_args_rtx))
    return 1;
  return 0;
}

/* address refering to the stack */
int
spaddr_operand (rtx op, enum machine_mode mode)
{
  if (mode == VOIDmode)
    mode = GET_MODE (op);
  if (GET_MODE (op) != mode)
    return 0;

  if (stack_register (op))
    return 1;
  if (REG_P (op) && REGNO (op) == REG_X && is_lowlevel ())
    return 1;
  if (GET_CODE (op) == PLUS)
    {
      rtx op1, op2;
      op1 = XEXP (op, 0);
      op2 = XEXP (op, 1);
      if (stack_register (op1) && CONSTANT_P (op2))
	return 1;
      if (REG_P (op1) && REGNO (op1) == REG_X && CONSTANT_P (op2)
	  && is_lowlevel ())
	return 1;
    }
  return 0;
}

/* start old code*/

int use_lowlevel = 0;

/* Return nonzero if X (an RTX) is a legitimate memory address on the target
   machine for a memory operand of mode MODE.  */

int
legitimate_address_p (enum machine_mode mode ATTRIBUTE_UNUSED,
		      rtx x, int strict)
{
  enum reg_class r = NO_REGS;

  if (REG_P (x) && (strict ? REG_OK_FOR_BASE_STRICT_P (x)
		    : REG_OK_FOR_BASE_NOSTRICT_P (x)))
    r = POINTER_REGS;
  else if (CONSTANT_ADDRESS_P (x))
    r = ALL_REGS;
  else if (GET_CODE (x) == PLUS
	   && GET_CODE (XEXP (x, 0)) == REG && CONSTANT_P (XEXP (x, 1)))
    {
      if (stack_register (XEXP (x, 0)))
	r = STACK_REG;
      else if (REG_P (XEXP (x, 0))
	  && (strict ? REG_OK_FOR_BASE_STRICT_P (XEXP (x, 0)) :
	      REG_OK_FOR_BASE_NOSTRICT_P (XEXP (x, 0))))
	{
	  if (GET_CODE (XEXP (x, 1)) == CONST_INT &&
	      INTVAL (XEXP (x, 1)) > 0 &&
	      GET_MODE_SIZE (mode) != 0 &&
	      GET_MODE_SIZE (mode) + INTVAL (XEXP (x, 1)) <= 8)
	    r = POINTER_REGS;
	}
      else
	r = NO_REGS;
    }

  return r == NO_REGS ? 0 : (int) r;
}

/* Attempts to replace X with a valid
   memory address for an operand of mode MODE  */

rtx
legitimize_address (rtx x, rtx oldx, enum machine_mode mode ATTRIBUTE_UNUSED)
{
  x = oldx;

  if (GET_CODE (oldx) == PLUS && REG_P (XEXP (oldx, 0)))
    {
      if (REG_P (XEXP (oldx, 1)))
	x = force_reg (GET_MODE (oldx), oldx);
      else
	{
	  x = force_reg (GET_MODE (oldx), oldx);

	}
    }
  return x;
}



/* Update the condition code in the INSN.  */

void
notice_update_cc (rtx body ATTRIBUTE_UNUSED, rtx insn)
{
  rtx set;

  switch (get_attr_cc (insn))
    {
    case CC_NONE:
      /* Insn does not affect CC at all.  */
      break;

    case CC_SET_N:
      CC_STATUS_INIT;
      break;

    case CC_SET_ZN:
      set = single_set (insn);
      CC_STATUS_INIT;
      if (set)
	{
	  cc_status.flags |= CC_NO_OVERFLOW;
	  cc_status.value1 = SET_DEST (set);
	}
      break;

    case CC_SET_CZN:
      /* Insn sets the Z,N,C flags of CC to recog_operand[0].
         The V flag may or may not be known but that's ok because
         alter_cond will change tests to use EQ/NE.  */
      set = single_set (insn);
      CC_STATUS_INIT;
      if (set)
	{
	  cc_status.value1 = SET_DEST (set);
	  cc_status.flags |= CC_NO_OVERFLOW;
	}
      break;

    case CC_COMPARE:
      set = single_set (insn);
      CC_STATUS_INIT;
      if (set)
	cc_status.value1 = SET_SRC (set);
      break;

    case CC_CLOBBER:
      /* Insn doesn't leave CC in a usable state.  */
      CC_STATUS_INIT;

      set = single_set (insn);
      if (set)
	cc_status.value1 = SET_DEST (set);
      cc_status.flags |= CC_NO_OVERFLOW;
      break;
    }
}

int
legitimize_reload_address (rtx * x,
			   enum machine_mode mode ATTRIBUTE_UNUSED,
			   int opnum, int type, int ind ATTRIBUTE_UNUSED)
{
  if (GET_CODE (*x) == PLUS
      && GET_CODE (XEXP (*x, 0)) == REG
      && REGNO (XEXP (*x, 0)) == REG_SP
      && GET_CODE (XEXP (*x, 1)) == CONST_INT)
    return 1;
  if (GET_CODE (*x) == PLUS
      && GET_CODE (XEXP (*x, 0)) == REG
      && REGNO (XEXP (*x, 0)) < FIRST_PSEUDO_REGISTER
      && GET_CODE (XEXP (*x, 1)) == CONST_INT
      && INTVAL (XEXP (*x, 1)) + GET_MODE_SIZE (mode) > 8)
    {
      push_reload (*x, NULL_RTX, x, NULL,
		   MODE_BASE_REG_CLASS (mode), GET_MODE (*x),
		   VOIDmode, 0, 0, opnum, (enum reload_type) type);
      return 1;
    }
  return 0;
}


static void
m68hc05_init_libfuncs (void)
{
  cmp_optab->handlers[(int) HImode].libfunc = init_one_libfunc ("__cmphi2");
  cmp_optab->handlers[(int) SImode].libfunc = init_one_libfunc ("__cmpsi2");
  ucmp_optab->handlers[(int) HImode].libfunc = init_one_libfunc ("__ucmphi2");
  ucmp_optab->handlers[(int) SImode].libfunc = init_one_libfunc ("__ucmpsi2");
}


#define IMM_COST 0
#define MEM_FIX_COST 0
#define MEM_SP_COST 2
#define MEM_POINTER_COST 100
#define MEM_POINTER_CALL 100

int
default_rtx_costs (rtx x,
		   enum rtx_code code, enum rtx_code outer_code, int *total)
{
  enum machine_mode mode = GET_MODE (x);
  int size;
  if (outer_code == MEM || code == MEM)
    {
      if (code == MEM && outer_code != MEM)
	{
	  size = GET_MODE_SIZE (mode);
	  x = XEXP (x, 0);
	}
      else
	size = 0;
      if (CONSTANT_P (x))
	{
	  *total = MEM_FIX_COST * size;
	  return 1;
	}
      if ((GET_CODE (x) == PLUS
	   && REG_P (XEXP (x, 0))
	   && CONSTANT_P (XEXP (x, 1))
	   && (REGNO (XEXP (x, 0)) == REG_SP || REGNO (XEXP (x, 0)) == REG_AG
	       || REGNO (XEXP (x, 0)) == REG_VFP
	       || REGNO (XEXP (x, 0)) == REG_FP)) || (REG_P (x)
						      && (REGNO (x) == REG_SP
							  || REGNO (x) ==
							  REG_AG
							  || REGNO (x) ==
							  REG_VFP
							  || REGNO (x) ==
							  REG_FP)))
	{
	  *total = MEM_SP_COST * size;
	  return 1;
	}
      if (REG_P (x))
	{
	  *total = MEM_POINTER_COST * size;
	  return 1;
	}

      if (GET_CODE (x) == ADDRESS)
	return 0;

      return 0;
    }

  if (CONSTANT_P (x))
    {
      if (mode != VOIDmode)
	{
	  *total = IMM_COST * GET_MODE_SIZE (mode);
	  return 1;
	}
      if (code == SYMBOL_REF)
	{
	  *total = IMM_COST * GET_MODE_SIZE (Pmode);
	  return 1;
	}
      if (code == LABEL_REF)
	{
	  *total = IMM_COST * GET_MODE_SIZE (Pmode);
	  return 1;
	}
      if (code == CONST_DOUBLE)
	{
	  *total = IMM_COST * GET_MODE_SIZE (DFmode);
	  return 1;
	}
      if (abs (INTVAL (x)) <= 0xff)
	{
	  *total = IMM_COST * 1;
	  return 1;
	}
      if (abs (INTVAL (x)) <= 0xffff)
	{
	  *total = IMM_COST * 2;
	  return 1;
	}
      if (abs (INTVAL (x)) <= 0xffffffff)
	{
	  *total = IMM_COST * 4;
	  return 1;
	}
    }

  if (outer_code == UNKNOWN)
    return 0;
  if (outer_code == SET)
    return 0;

  return 0;
}

static bool
m68hc05_rtx_costs (rtx x, int code, int outer_code, int *total)
{
  return default_rtx_costs (x, code, outer_code, total);
}

int
m68hc05_address_cost (rtx x)
{
  if (CONSTANT_P (x))
    return 0;
  if ((GET_CODE (x) == PLUS
       && REG_P (XEXP (x, 0))
       && CONSTANT_P (XEXP (x, 1))
       && (REGNO (XEXP (x, 0)) == REG_SP || REGNO (XEXP (x, 0)) == REG_AG
	   || REGNO (XEXP (x, 0)) == REG_VFP
	   || REGNO (XEXP (x, 0)) == REG_FP)) || (REG_P (x)
						  && (REGNO (x) == REG_SP
						      || REGNO (x) ==
						      REG_AG
						      || REGNO (x) ==
						      REG_VFP
						      || REGNO (x) ==
						      REG_FP)))
    return 2;
  if (REG_P (x))
    return 10;

  return 100;
}

int
register_move_cost (enum machine_mode mode,
		    enum reg_class from, enum reg_class to)
{
  int cost = 2;
  if (from == A_REG || from == X_REG)
    cost--;
  if (to == A_REG || to == X_REG)
    cost--;
  if (to == STACK_REG && (from == A_REG || from == X_REG))
    cost += 2;
  if (from == STACK_REG && (to == A_REG || to == X_REG))
    cost += 2;
  return cost * GET_MODE_SIZE (mode);
}

int
memory_move_cost (enum machine_mode mode,
		  enum reg_class regclass, int in ATTRIBUTE_UNUSED)
{
  int cost = 4;
  if (regclass == A_REG || regclass == X_REG)
    cost -= 2;
  return cost * GET_MODE_SIZE (mode);
}


int
is_rega_rtx (rtx x)
{
  if (REG_P (x) && REGNO (x) == REG_A)
    return 1;
  return 0;
}

int
is_regx_rtx (rtx x)
{
  if (REG_P (x) && REGNO (x) == REG_X)
    return 1;
  return 0;
}

int
is_lowlevel (void)
{
  if (!reload_completed)
    use_lowlevel = 0;
  return use_lowlevel;
}

static void
m68hc05_reorg (void)
{
  rtx insns = get_insns ();
  rtx insn, note;

  if (optimize > 0)
    {
      reload_cse_regs (insns);
    }

  for (insn = insns; insn; insn = NEXT_INSN (insn))
    if (INSN_P (insn))
      {
	while ((note = find_reg_note (insn, REG_BR_PROB, NULL)))
	  remove_note (insn, note);
	if (rtx_equal_p (PATTERN (insn), const0_rtx))
	  delete_insn (insn);
      }

  find_basic_blocks (insns);
  life_analysis (dump_file, PROP_REG_INFO | PROP_DEATH_NOTES);
  rebuild_jump_labels (insns);

  use_lowlevel = 1;

  split_all_insns (0);

  for (insn = insns; insn; insn = NEXT_INSN (insn))
    if (INSN_P (insn))
      {
	while ((note = find_reg_note (insn, REG_BR_PROB, NULL)))
	  remove_note (insn, note);
	if (rtx_equal_p (PATTERN (insn), const0_rtx))
	  delete_insn (insn);
      }

  if (dump_file)
    {
      print_rtl_with_bb (dump_file, insns);
      fprintf (dump_file, "*1**************\n");
    }

  if (optimize > 0)
    {
      reload_cse_regs (insns);

      if (dump_file)
	{
	  print_rtl_with_bb (dump_file, insns);
	  fprintf (dump_file, "*2**************\n");
	}

    }


  find_basic_blocks (insns);
  life_analysis (dump_file, PROP_REG_INFO | PROP_DEATH_NOTES);
  rebuild_jump_labels (insns);

  if (dump_file)
    {
      print_rtl_with_bb (dump_file, insns);
      fprintf (dump_file, "*3**************\n");
    }

  if (optimize > 0)
    {
/*
#ifdef ENABLE_CHECKING
      verify_flow_info ();
#endif

      regmove_optimize (insns , max_reg_num (), dump_file);
      cleanup_cfg (CLEANUP_EXPENSIVE | CLEANUP_UPDATE_LIFE);
      //cse_main (insns, max_reg_num (), dump_file);
      gcse_after_reload_main (insns);
      rebuild_jump_labels (insns);
      delete_trivially_dead_insns (insns, max_reg_num ());
      gcse_main (insns, dump_file);
      rebuild_jump_labels (insns);
      delete_trivially_dead_insns (insns, max_reg_num ());
      delete_dead_jumptables ();
      
      regrename_optimize ();
      copyprop_hardreg_forward();

#ifdef ENABLE_CHECKING
      verify_flow_info ();
#endif

      regmove_optimize (insns , max_reg_num (), dump_file);
      cleanup_cfg (CLEANUP_EXPENSIVE | CLEANUP_UPDATE_LIFE);
      //cse_main (insns, max_reg_num (), dump_file);
      gcse_after_reload_main (insns);
      rebuild_jump_labels (insns);
      delete_trivially_dead_insns (insns, max_reg_num ());
      gcse_main (insns, dump_file);
      rebuild_jump_labels (insns);
      delete_trivially_dead_insns (insns, max_reg_num ());
      delete_dead_jumptables ();

      regrename_optimize ();
      copyprop_hardreg_forward();
      reload_cse_regs (insns);

#ifdef ENABLE_CHECKING
      verify_flow_info ();
#endif
*/
      if (dump_file)
	{
	  print_rtl_with_bb (dump_file, insns);
	  fprintf (dump_file, "*4**************\n");
	}

    }

  find_basic_blocks (insns);
  life_analysis (dump_file, PROP_REG_INFO | PROP_DEATH_NOTES);
  rebuild_jump_labels (insns);

}

void
m68hc05_override_options (void)
{
}
void
m68hc05_optimization_options (int level ATTRIBUTE_UNUSED,
			      int size ATTRIBUTE_UNUSED)
{
  if (size)
    {
      set_param_value ("max-inline-insns-single", 60);
      set_param_value ("max-inline-insns-auto", 12);
    }

}

int
in_optimizing (void)
{
  return 0;
  return n_edges != 0;
}

/* generic address space attribute handler */
static tree
m68hc05_handle_addrspace_attribute (tree * node, tree name,
				    enum addrspace_type space)
{
  if (POINTER_TYPE_P (*node))
    {
      *node = copy_node (*node);
      TYPE_ADDRSPACE (*node) = space;
      TYPE_SIZE (*node) = 0;
      TYPE_MODE (*node) = GET_ADDRSPACE_MODE (TYPE_ADDRSPACE (*node));
      layout_type (*node);
    }
  else if (DECL_P (*node) && TREE_CODE (*node) != TYPE_DECL
	   && TREE_CODE (*node) != PARM_DECL)
    {
      *node = copy_node (*node);
      DECL_ADDRSPACE (*node) = space;
    }
  else
    warning (0, "%qs attribute does not apply", IDENTIFIER_POINTER (name));

  return NULL_TREE;
}

/* Handle a "eeprom" attribute; arguments as in
   struct attribute_spec.handler.  */
static tree
m68hc05_handle_eeprom_attribute (tree * node, tree name,
				 tree args ATTRIBUTE_UNUSED,
				 int flags ATTRIBUTE_UNUSED,
				 bool * no_add_attrs ATTRIBUTE_UNUSED)
{
  return m68hc05_handle_addrspace_attribute (node, name, EEPROMspace);
}

/* Handle a "loram" attribute; arguments as in
   struct attribute_spec.handler.  */
static tree
m68hc05_handle_loram_attribute (tree * node, tree name,
				tree args ATTRIBUTE_UNUSED,
				int flags ATTRIBUTE_UNUSED,
				bool * no_add_attrs ATTRIBUTE_UNUSED)
{
  return m68hc05_handle_addrspace_attribute (node, name, LORAMspace);
}

/* Handle an attribute requiring a FUNCTION_DECL; arguments as in
   struct attribute_spec.handler.  */

static tree
m68hc05_handle_fndecl_attribute (tree * node, tree name,
				 tree args ATTRIBUTE_UNUSED,
				 int flags ATTRIBUTE_UNUSED,
				 bool * no_add_attrs)
{
  if (TREE_CODE (*node) != FUNCTION_DECL)
    {
      warning (0, "%qs attribute only applies to functions",
	       IDENTIFIER_POINTER (name));
      *no_add_attrs = true;
    }
  return NULL_TREE;
}

const struct attribute_spec m68hc05_attribute_table[] = {
  /* { name, min_len, max_len, decl_req, type_req, fn_type_req, handler } */
  {"eepromt", 0, 0, false, true, false, m68hc05_handle_eeprom_attribute},
  {"eeprom", 0, 0, true, false, false, m68hc05_handle_eeprom_attribute},
  {"loramt", 0, 0, false, true, false, m68hc05_handle_loram_attribute},
  {"loram", 0, 0, true, false, false, m68hc05_handle_loram_attribute},
  {"nosave", 0, 0, true, false, false, m68hc05_handle_fndecl_attribute},
  {NULL, 0, 0, false, false, false, NULL}
};

/* Return nonzero if FUNC is a nosave function.  */

static int
m68hc05_nosave_function_p (tree func)
{
  tree a;

  if (TREE_CODE (func) != FUNCTION_DECL)
    abort ();

  a = lookup_attribute ("nosave", DECL_ATTRIBUTES (func));
  return a != NULL_TREE;
}


void
m68hc05_init_builtins (void)
{
  tree type;
  type = make_signed_type (GET_MODE_BITSIZE (AImode));
  (*lang_hooks.types.register_builtin_type) (type, "__sintAI");
  type = make_unsigned_type (GET_MODE_BITSIZE (AImode));
  (*lang_hooks.types.register_builtin_type) (type, "__uintAI");
  type = make_signed_type (GET_MODE_BITSIZE (FImode));
  (*lang_hooks.types.register_builtin_type) (type, "__sintFI");
  type = make_unsigned_type (GET_MODE_BITSIZE (FImode));
  (*lang_hooks.types.register_builtin_type) (type, "__uintFI");
  type = make_signed_type (GET_MODE_BITSIZE (CImode));
  (*lang_hooks.types.register_builtin_type) (type, "__sintCI");
  type = make_unsigned_type (GET_MODE_BITSIZE (CImode));
  (*lang_hooks.types.register_builtin_type) (type, "__uintCI");
  type = make_signed_type (GET_MODE_BITSIZE (EImode));
  (*lang_hooks.types.register_builtin_type) (type, "__sintEI");
  type = make_unsigned_type (GET_MODE_BITSIZE (EImode));
  (*lang_hooks.types.register_builtin_type) (type, "__uintEI");
}

static bool
m68hc05_scalar_mode_supported_p (enum machine_mode mode)
{
  if (default_scalar_mode_supported_p (mode))
    return true;

  switch (mode)
    {
    case AImode:
    case EImode:
    case FImode:
    case CImode:
      return true;
    default:
      return false;
    }
}

static int
m68hc05_extract_mem_ref_flags (tree expr)
{
  enum addrspace_type ref = tree_get_addrspace (expr);
  if (TYPE_P (expr))
    ref = DEFAULTspace;

  if (ref == NONEspace)
    {
      if (TREE_CODE (expr) == CONSTRUCTOR)
	ref = DEFAULTspace;
    }

  gcc_assert (ref != NONEspace);
  if (ref == LORAMspace)
    return 2;
  if (ref == EEPROMspace)
    return 1;
  else
    return 0;
}

static int
m68hc05_compare_addrspace (enum addrspace_type to, enum addrspace_type from)
{
  if (from == to)
    return 1;
  /* loosing EEPROM addrspace */
  if (to == DEFAULTspace && from == EEPROMspace)
    return 2;
  /* LORAM -> DEFAULT: OK */
  if (to == DEFAULTspace && from == LORAMspace)
    return 1;
  return 0;
}

enum addrspace_type
m68hc05_merge_addrspace (enum addrspace_type a ATTRIBUTE_UNUSED,
			 enum addrspace_type b ATTRIBUTE_UNUSED)
{
  if (a == b)
    return a;
  if (a == EEPROMspace && b == DEFAULTspace)
    return DEFAULTspace;
  if (a == DEFAULTspace && b == EEPROMspace)
    return DEFAULTspace;
  if (a == LORAMspace && b == DEFAULTspace)
    return DEFAULTspace;
  if (a == DEFAULTspace && b == LORAMspace)
    return DEFAULTspace;
  return NONEspace;
}
